offsetMargin = 0.1;
$fn = 100;

createBlocks();

module createBlocks(numberOfBlocks = 10, largestBlockRadius = 25.0, largestBlockHeight = 6.0, stacked = false, angledPieces = false)
{
    // Stacking Bump Variables
    stackingBumpRadiusScale = 0.25;
    stackingBumpHeightScale = 0.5;
    stackingBumpFemaleMargin = 0.3; //mm
    
    // Height Variables
    smallestBlockHeight = largestBlockHeight * 0.5;
    blockHeightEquationSlope = (smallestBlockHeight - largestBlockHeight) / (numberOfBlocks - 1);
    blockHeightEquationB = largestBlockHeight - blockHeightEquationSlope;
    blockHeights = [blockHeightEquationSlope * 1 + blockHeightEquationB, blockHeightEquationSlope * 2 + blockHeightEquationB, blockHeightEquationSlope * 3 + blockHeightEquationB, blockHeightEquationSlope * 4 + blockHeightEquationB, blockHeightEquationSlope * 5 + blockHeightEquationB, blockHeightEquationSlope * 6 + blockHeightEquationB, blockHeightEquationSlope * 7 + blockHeightEquationB, blockHeightEquationSlope * 8 + blockHeightEquationB, blockHeightEquationSlope * 9 + blockHeightEquationB, blockHeightEquationSlope * 10 + blockHeightEquationB, blockHeightEquationSlope * 11 + blockHeightEquationB, blockHeightEquationSlope * 12 + blockHeightEquationB, blockHeightEquationSlope * 13 + blockHeightEquationB, blockHeightEquationSlope * 14 + blockHeightEquationB, blockHeightEquationSlope * 15 + blockHeightEquationB, blockHeightEquationSlope * 16 + blockHeightEquationB, blockHeightEquationSlope * 17 + blockHeightEquationB, blockHeightEquationSlope * 18 + blockHeightEquationB, blockHeightEquationSlope * 19 + blockHeightEquationB, blockHeightEquationSlope * 20 + blockHeightEquationB];
    
    // Radius Variables
    smallestBlockRadius = largestBlockRadius * 0.5;
    blockRadiusEquationSlope = (smallestBlockRadius - largestBlockRadius) / (numberOfBlocks - 1);
    blockRadiusEquationB = largestBlockRadius - blockRadiusEquationSlope;
    blockRadiuss = [blockRadiusEquationSlope * 1 + blockRadiusEquationB, blockRadiusEquationSlope * 2 + blockRadiusEquationB, blockRadiusEquationSlope * 3 + blockRadiusEquationB, blockRadiusEquationSlope * 4 + blockRadiusEquationB, blockRadiusEquationSlope * 5 + blockRadiusEquationB, blockRadiusEquationSlope * 6 + blockRadiusEquationB, blockRadiusEquationSlope * 7 + blockRadiusEquationB, blockRadiusEquationSlope * 8 + blockRadiusEquationB, blockRadiusEquationSlope * 9 + blockRadiusEquationB, blockRadiusEquationSlope * 10 + blockRadiusEquationB, blockRadiusEquationSlope * 11 + blockRadiusEquationB, blockRadiusEquationSlope * 12 + blockRadiusEquationB, blockRadiusEquationSlope * 13 + blockRadiusEquationB, blockRadiusEquationSlope * 14 + blockRadiusEquationB, blockRadiusEquationSlope * 15 + blockRadiusEquationB, blockRadiusEquationSlope * 16 + blockRadiusEquationB, blockRadiusEquationSlope * 17 + blockRadiusEquationB, blockRadiusEquationSlope * 18 + blockRadiusEquationB, blockRadiusEquationSlope * 19 + blockRadiusEquationB, blockRadiusEquationSlope * 20 + blockRadiusEquationB];
    
    for(i = [0 : numberOfBlocks - 1])
    {
        if(stacked)
        {
            translate(v = [0, 0, largestBlockHeight * i + offsetMargin * i])
            {
                union()
                {
                    if(angledPieces)
                    {
                        difference()
                        {
                            // Main body
                            cylinder(r1 = blockRadiuss[i], r2 = blockRadiuss[i + 1], h = blockHeights[i]);
                            
                            translate(v = [0, 0, -offsetMargin])
                            {
                                // Stacking Bump cutout
                                cylinder(r1 = blockRadiuss[0] * stackingBumpRadiusScale + stackingBumpFemaleMargin, r2 = blockRadiuss[0] * stackingBumpRadiusScale + stackingBumpFemaleMargin, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale + stackingBumpFemaleMargin * 2);
                            }
                        }
                        
                        // Stacking Bump
                        translate(v = [0, 0, blockHeights[i] - offsetMargin])
                        {
                            cylinder(r1 = blockRadiuss[0] * stackingBumpRadiusScale, r2 = blockRadiuss[0] * stackingBumpRadiusScale, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale);
                        }
                    }
                    else
                    {
                        difference()
                        {
                            // Main body
                            cylinder(r = blockRadiuss[i], h = blockHeights[i]);
                            
                            translate(v = [0, 0, -offsetMargin])
                            {
                                // Stacking Bump cutout
                                cylinder(r = blockRadiuss[0] * stackingBumpRadiusScale + stackingBumpFemaleMargin, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale + stackingBumpFemaleMargin * 2);
                            }
                        }
                        
                        // Stacking Bump
                        translate(v = [0, 0, blockHeights[i] - offsetMargin])
                        {
                            cylinder(r = blockRadiuss[0] * stackingBumpRadiusScale, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale);
                        }
                    }
                }
            }
        }
        else
        {
            translate(v = [0, (largestBlockRadius * 2) * i, 0])
            {
                union()
                {
                    if(angledPieces)
                    {
                        difference()
                        {
                            // Main body
                            cylinder(r1 = blockRadiuss[i], r2 = blockRadiuss[i + 1], h = blockHeights[i]);
                            
                            translate(v = [0, 0, -offsetMargin])
                            {
                                // Stacking Bump cutout
                                cylinder(r1 = blockRadiuss[0] * stackingBumpRadiusScale + stackingBumpFemaleMargin, r2 = blockRadiuss[0] * stackingBumpRadiusScale + stackingBumpFemaleMargin, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale + stackingBumpFemaleMargin * 2);
                            }
                        }
                        
                        // Stacking Bump
                        translate(v = [0, 0, blockHeights[i] - offsetMargin])
                        {
                            cylinder(r1 = blockRadiuss[0] * stackingBumpRadiusScale, r2 = blockRadiuss[0] * stackingBumpRadiusScale, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale);
                        }
                    }
                    else
                    {
                        difference()
                        {
                            // Main body
                            cylinder(r = blockRadiuss[i], h = blockHeights[i]);
                            
                            translate(v = [0, 0, -offsetMargin])
                            {
                                // Stacking Bump cutout
                                cylinder(r = blockRadiuss[0] * stackingBumpRadiusScale + stackingBumpFemaleMargin, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale + stackingBumpFemaleMargin * 2);
                            }
                        }
                        
                        // Stacking Bump
                        translate(v = [0, 0, blockHeights[i] - offsetMargin])
                        {
                            cylinder(r = blockRadiuss[0] * stackingBumpRadiusScale, h = blockHeights[numberOfBlocks - 1] * stackingBumpHeightScale);
                        }
                    }
                }
            }
        }
    }
}
